import { Injectable } from '@angular/core';
import { WebSocketService } from './websocket.service';
import { Subject } from 'rxjs/Subject';
import { ProcessLogCommand } from './processlog-command';
import { config } from '../config';

@Injectable()
export class ProcessLogService {
  newLog = new Subject<any>();
  showLiveLogs = config.console.showLiveLogs;

  command_handlers = {
    'new_log': this.newLogHandler.bind(this)
  };

  constructor(private webSocketService: WebSocketService) {
    this.webSocketService.connect();
    this.webSocketService.observeKey<ProcessLogCommand>('processlog').subscribe(
      (event) => this.command_handlers[event.data.command](event.data)
    );
  }

  newLogHandler(data: ProcessLogCommand) {
    if (this.showLiveLogs) {
      this.newLog.next({
        stdout: data.stdout,
        stderr: data.stderr
      });
    }
  }
}
